package betterwithmods.event;

import betterwithmods.common.items.ItemMaterial;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.item.ItemStack;
import net.minecraft.util.DamageSource;
import net.minecraftforge.event.entity.living.LivingHurtEvent;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.items.CapabilityItemHandler;
import net.minecraftforge.items.IItemHandler;

/**
 * Purpose:
 *
 * @author Tyler Marshall
 * @version 11/26/16
 */
public class BlastingOilEvent {
    @SubscribeEvent
    public void onPlayerTakeDamage(LivingHurtEvent e) {
        DamageSource BLAST_OIL = new DamageSource("blastingoil");
        EntityLivingBase living = e.getEntityLiving();
        if (living.hasCapability(CapabilityItemHandler.ITEM_HANDLER_CAPABILITY, null)) {
            IItemHandler inventory = living.getCapability(CapabilityItemHandler.ITEM_HANDLER_CAPABILITY, null);
            int count = 0;
            for (int i = 0; i < inventory.getSlots(); i++) {
                ItemStack stack = inventory.getStackInSlot(i);

                if (!stack.func_190926_b() && stack.func_77969_a(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.BLASTING_OIL))) {
                    count += stack.func_190916_E();
                    inventory.extractItem(i, stack.func_190916_E(), false);
                }
            }
            if (count > 0) {
                living.func_70097_a(BLAST_OIL, Float.MAX_VALUE);
                living.func_130014_f_().func_72876_a(null, living.field_70165_t, living.field_70163_u + living.field_70131_O / 16, living.field_70161_v, (float) (Math.sqrt(count / 5) / 2.5 + 1), true);
            }
        }
    }
}
